#include <windows.h>   
#include <math.h>   

const float MISSING = (float) 3.4e38;


_declspec(dllexport) void MADH (float *Close, long ShortLength, long DominantCycle, long numrows, float *output )
{
	// MADH (Moving Average Difference - Hann) Indicator
	// (C) 2021 John F. Ehlers

	long LongLength=20, count=0, bar=0, CurrentBar=0;
	double Filt1=0.0, Filt2=0.0, coef=0.0, MADH=0.0;

	double radiansconvertmult;
	radiansconvertmult = 3.1415926535 / 180.0;
	
	LongLength = (long) (ShortLength + DominantCycle / 2.0);
	for ( CurrentBar=0; CurrentBar<numrows; CurrentBar++ )
	{	if ( CurrentBar >= ShortLength && CurrentBar >= LongLength)
		{	
			Filt1 = 0;
			coef = 0;
			for ( count = 1; count <= ShortLength; count++ )
			{	bar = CurrentBar - (count - 1);
				Filt1 = Filt1 + (1 - cos(radiansconvertmult*360*count / (ShortLength + 1)))*Close[bar];
				coef = coef + (1 - cos(radiansconvertmult*360*count / (ShortLength + 1)));
			}
			if ( coef != 0 ) Filt1 = Filt1 / coef;

			Filt2 = 0;
			coef = 0;
			for ( count = 1; count <= LongLength; count++ )
			{	bar = CurrentBar - (count - 1);
				Filt2 = Filt2 + (1 - cos(radiansconvertmult*360*count / (LongLength + 1)))*Close[bar];
				coef = coef + (1 - cos(radiansconvertmult*360*count / (LongLength + 1)));
			}
			if ( coef != 0 ) Filt2 = Filt2 / coef;

			//Computed as percentage of price
			if ( Filt2 != 0 ) MADH = 100*(Filt1 - Filt2) / Filt2;
			output[CurrentBar] = (float) MADH;
		}
	}
}


